<script lang="ts">
  export let value: number;
  export let inline: boolean = false;

  function getStyle(cardValue: number) {
    let idx = cardValue - 3;
    let hue = (185 - (360 / 38) * idx) % 360;
    let lightness = 60;
    if (cardValue > 31) {
      lightness -= (cardValue - 31) * 5;
    }

    let centerLightness = lightness + 5;
    let outerLightness = lightness - 15;

    return `background: radial-gradient(hsl(${hue},70%,${centerLightness}%), hsl(${hue},70%,${outerLightness}%))`;
  }
</script>

{#if inline}
  <strong class="inline value" style={getStyle(value)}>{value}</strong>
{:else}
  <div class="wrapper border shadow">
    <div class="inner" style={getStyle(value)}>
      <div class="corner value">{value}</div>
      <div class="center value">{value}</div>
    </div>
  </div>
{/if}

<style>
  .wrapper {
    background-color: linen;
    position: relative;
    width: 10em;
    height: 14em;
    border-radius: 7% / 5%;
  }

  .inner {
    border-radius: calc(7% * 0.667) / calc(5% * 0.667);
    position: absolute;
    top: 5%;
    bottom: 5%;
    left: 7%;
    right: 7%;
  }

  .value {
    font-weight: 900;
    color: snow;
    text-shadow: 0 0 3px #0008, 0 0 2px #000f;
  }

  .corner.value {
    font-size: 1.6em;
    position: absolute;
    top: 0;
    left: 0;

    width: 1.5em;
    text-align: center;
  }

  .center.value {
    font-size: 4.5em;

    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .inline {
    padding: 0.25em;
    border-radius: 4px;
  }
</style>
